;_______________________________________________________________________
; pro leeFR,name,fri,frq,fru,frv,ntau,nlam
;_______________________________________________________________________

; este procedure lee las FR escitas con SIR (version 18 Mayo del 1999)
; Para evaluarlas basta con ejecutar SIR poniendo nciclos=-1
; Se calcularan las FR de aquellos parametros que tengan un numero
; de nodos distinto de cero 
; ATENSION o GUARNIN: si se introducen un modelo de 2 componentes
; las FR saldran escaladas al peso de cada componente

; name es el nombre del fichero ej:  'model.rt' es la unica entrada

; nlam es el numero total de longitudes de onda de los perfiles
;      teniendo en cuenta todas las lineas sintetizadas
;      es decir las FR de las diferentes lineas salen concatenadas
;      en ldo.

; ntau es el numero de profundidades en las que se evaluo la FR
;      para los parametros univaluados vale 1

; fri=float(nlam,ntau) es la FR de I
; frq=float(nlam,ntau) es la FR de Q
; fru=float(nlam,ntau) es la FR de U
; frv=float(nlam,ntau) es la FR de V

; Todas las FR:
;       -- Son a perturbaciones absolutas
;       -- Estan normalizadas a la Intensidad del continuo del HSRA
;          en el centro del disco evaluada a la longitud de onda 
;          central de cada linea  
;       -- Estan multiplicadas por el paso en profundidad del modelo
;_______________________________________________________________________

pro leeFR,name,fri,frq,fru,frv,ntau,nlam

openr,1,name
readf,1,ntau,nlam4

ntau=long(ntau)
nlam4=long(nlam4)
n=ntau*nlam4

data=fltarr(n)
readf,1,data
close,1

nlam=nlam4/4

d2=reform(data,nlam,4,ntau)
fri=reform(d2(*,0,*))
frq=reform(d2(*,1,*))
fru=reform(d2(*,2,*))
frv=reform(d2(*,3,*))

return
end
;_______________________________________________________________________




