	subroutine hermite_c(s,ds,etall,n,svec,nn,bt,tk,pk,
     &           vk,mk,rt,rp,rv,rm)

        implicit real*4 (a-h,o-z)
	include 'PARAMETER'   !por kt
        parameter (kt16=16*kt)
        parameter (dl10=2.3025851)

	integer n,nn
	real*4 svec

c internas
        real*4 sol(kt),tau(kt),taue(kt)
        real*4 deltae(kt),deltai(kt),delt2i(kt)
	real*4 ds(*), detal(kt), etal(kt), etall(*)
	real*4 etal2(kt)
	real*4 s(*), den, num, den2
	real*4 OO(kt)
        real*4 tk(kt),pk(kt),vk(kt),mk(kt)
	real*4 bt(kt)
	real*4 rt(*),rp(*),rv(*),rm(*)
c       deltae(i)=(taue(i)-taue(i+1))
c       deltai(i) = (tau(i)-tau(i-1))/2.
c       delt2i(i) = delta(i)*delta(i)/3. 
        common/segunda/tau,taue,deltae,deltai,delt2i


c se calcula la derivada de la matriz de absorcion
	do i=1,n
	   etal(i) = etall(i)*taue(i)*dl10
  	end do 	
	call derivacuad(etal,detal,n,tau)

c se integra
	do i=1,n
  	   etal2(i) = etal(i)*etal(i)
	enddo

	sol(1) = s(1) + ds(1)/etal(1)

 	do i=2,n
           delta=deltai(i)
           delt2=delt2i(i)
           e0=etal(i-1)
	   e1=etal(i)
           s00=s(i-1)
           s01=s(i)
	   den =-( e0*s00 + e1*s01 )*
     &	                 delta + sol(i-1)
	   den =-(detal(i-1)*s00 - detal(i)*s01  +
     &                  e0*ds(i-1) -  e1*ds(i) +
     &                  etal2(i-1)*s00 - etal2(i)*s01 )*
     &                  delt2 + den

	   den2=etal(i-1)*delta+
     & delt2*(detal(i-1)+etal2(i-1))
	   den=den + (etal(i-1)*delta+
     & delt2*(detal(i-1)+etal2(i-1)))*sol(i-1)
	   num= - etal(i)*delta + 
     & delt2*(detal(i)+etal2(i))
	   num = 1.0 + num
	   den2 = 1.0 + den2
        
	   OO(i-1) = den2/num
	      
	   sol(i) = den/num
	enddo

	svec = sol(n)

	OO(n) = 1.0

	do i=n-2,1,-1
	   OO(i)=OO(i+1)*OO(i)
	enddo

c calculamos las f.resp

	do i=1,n-1
           ss=sol(i) - s(i)
           ooo=OO(i)

           rt(i)=ooo*(tk(i)*ss-etall(i)*bt(i))
           rp(i)=ooo*pk(i)*ss
           rv(i)=ooo*vk(i)*ss
           rm(i)=ooo*mk(i)*ss
c           print*,'ooo,tk,ss,etall,bt=',ooo,tk(i),ss,etall(i),bt(i)
	   
	enddo
	rt(n)=0.
	rp(n)=0.
	rv(n)=0.
	rm(n)=0.

	return
	end
c ________________________________________________________________________

